       program metnxs
c!***** metnxs finds datasets and lists metadata
c gfortran -o scannxs scannxs.f h5bits.o libhdf5_fortran.a libhdf5.a -lz 
      parameter (NXY=100*256*128)
      common/debh5/ideb
      common/scannxc/igf
      common/scannam/dnames
      common/scannml/nnam,nl(500)
      common/h5com/v
      real v(NXY)
      integer iv(NXY),idim(10)
      character vc*1000
      character dnames(500)*100
      character fname*60,namout*30,dsname*100,arrsiz*20,typ*3,fp*40
      character*80 gname,gname1,gname2
      character*10 debtxt
      logical found
      equivalence(v,iv,vc)
      debtxt=' '
      call getenv('SAS_DEBUG',debtxt)
      ideb=index(debtxt,' ')
      if(ideb.eq.1) ideb=0
      igf=0
      write(6,1)
1     format(' metnxs - shows datasets in .nxs files ')
      narg=iargc()
      if(narg.gt.0) go to 10
      write(6,2)
2     format(' Give filename : ',$)
      read(5,4) fname
4     format(a)
      go to 101
10    fname=' '
      call getarg(1,fname)
101   igf=0
      lf=len_trim(fname)
      gname=''
      lg=len_trim(gname)
      inquire(file=fname(1:lf),exist=found)
      if(.not.found) call stopms('No input file found')
c***** for output file need to have name before ext
      call filde(fname(1:lf),nd,ne)
      call scanxs(fname(1:lf),gname(1:lg))
      fp=fname(nd:ne)//'_meta.lis'
      open(unit=16,file=fp,status='unknown')
      write(6,*) ' HDF5/Nexus file :  ',fname
      write(16,*) ' HDF5/Nexus file :  ',fname
      write(6,*)' There are ',nnam,' datasets present ',ideb
      write(16,*)' There are ',nnam,' datasets present'
      call oldh5(ier,id_f,fname(1:lf),'O')
      if(ier.ne.0) call stopms('h5 file open error')
      do j=1,nnam
      dsname=dnames(j)(2:100)
      ld=len_trim(dsname)
c      write(*,*) ld,dsname(1:ld)
      call infods(ier,id_f,dsname(1:ld),isiz,ir,idim,itype)
      typ='X'
      if(itype.eq.0) typ='C'
      if(itype.eq.1) typ='I'
      if(itype.eq.2) typ='F'
      arrsiz='('
      larr=3
      ntot=idim(1)
      write(arrsiz(larr:20),550) ntot
550   format(i4,',')
      larr=larr+5
      do k=2,ir
      if(idim(k).gt.0) ntot=ntot*idim(k)
      write(arrsiz(larr:20),550) idim(k)
      larr=larr+5
      end do
c      write(*,*) 'Total in dsname ',dsname(1:ld),ntot
      arrsiz(larr-1:larr-1)=')'
      larr=larr-1
      nttt=ntot
      iitype=itype
      idim(1)=100
      if(ntot.lt.100) 
     1call readds(ier,id_f,dsname(1:ld),v,ir,idim,iitype)
      if(ntot.gt.100) ntot=0
      if(iitype.eq.0) ntot=idim(1)
      if(iitype.eq.0) 
     1write(6,60) j,dsname(1:60),typ,vc(1:ntot)
      if(iitype.eq.0) 
     1write(16,60) j,dsname(1:60),typ,vc(1:ntot)
60    format(i4,2x,a,a,'"',a,'"')
      if(iitype.eq.1.and.ntot.eq.1) 
     1write(6,61) j,dsname(1:60),typ,iv(1)
      if(iitype.eq.1.and.ntot.eq.1) 
     1write(16,61) j,dsname(1:60),typ,iv(1)
61    format(i4,2x,a,a,i10)
      if(iitype.eq.1.and.nttt.gt.1)
     1write(6,62) j,dsname(1:60),typ,arrsiz(1:larr),(iv(i),i=1,ntot)
62    format(i4,2x,a,a,a,(5i10))
      if(iitype.eq.1.and.nttt.gt.1)
     1write(16,62) j,dsname(1:60),typ,arrsiz(1:larr),(iv(i),i=1,ntot)
      if(iitype.eq.2.and.nttt.eq.1) 
     1write(6,71) j,dsname(1:60),typ,v(1)
      if(iitype.eq.2.and.nttt.eq.1) 
     1write(16,71) j,dsname(1:60),typ,v(1)
71    format(i4,2x,a,a,g14.5)
      if(iitype.eq.2.and.nttt.gt.1)
     1write(6,72) j,dsname(1:60),typ,arrsiz(1:larr),(v(i),i=1,ntot)
72    format(i4,2x,a,a,a,(5g14.5))
      if(iitype.eq.2.and.nttt.gt.1)
     1write(16,72) j,dsname(1:60),typ,arrsiz(1:larr),(v(i),i=1,ntot)
      end do
      call oldh5(ier,id_f,fname(1:lf),'C')
      close(unit=16)
      write(6,90) fp
90    format(' Closing listing file ',a)
c***** for prop/dos pause a while
      call stopms('finishing')
      stop 
      end
      subroutine filde(fnam,nd,ne)
c***** extracts filname from dir (slash-backslash) and ext(.)
      character*(*) fnam
      character sl*1,bsl*1,dot*1
      sl='/'
      dot='.'
      bsl=char(92)
      lf=len(fnam)
      nd=0
      ne=0     
      do i=lf,1,-1
        if(fnam(i:i).eq.sl.and.nd.eq.0) nd=i+1
        if(fnam(i:i).eq.bsl.and.nd.eq.0) nd=i+1
        if(fnam(i:i).eq.dot.and.ne.eq.0) ne=i-1
      end do
      if(nd.le.0) nd=1
      if(ne.le.0) ne=lf
      return
      end
      subroutine stopms(msg)
c***** for prop on MS pause before closing window
      character*(*) msg
      character*20 os
      if(msg.eq.' ') stop
      write(6,*) msg
      call getenv('OS',os)
      if(os.eq.'Windows_NT') call sleep(5)
      stop
      end
