      program runnex
c***** prints paras from nxs files
c ./h5fc -o runnex runnex.f h5bits.o
c
      parameter(NXY=100*512*512)
      common/rbuf/v(NXY)
      common/cindx/ionce,numor
      common/ccolt/coltit(12)
      character inst*3,path*100,fname*100,lin*80,linn*90,seln*10,ic*1
      character numc*6,coltit*12,selfil*100
      logical found
      equivalence(lin,linn)
      ionce=0
      iconce=0
      linn=' '
      linn(80:90)=' 0 0 0 0 /'
      inst=' '
      selfil=' '
      path=' '
      call getenv('SAS_INSTRUMENT',inst)
      if(inst.eq.' ') call stopms ('SAS_INSTRUMENT not defined')
      path=' '
      call getenv('SAS_DATA_PATH',path)
      if(path.eq.' ') call stopms('SAS_DATA_PATH not defined')
      lp=len_trim(path)
c***** look for parameter file dictionary
      ic=inst(2:2)
      if(ic.eq.'1') seln='D11par.sel'
      if(ic.eq.'2') seln='D22par.sel'
      if(ic.eq.'3') seln='D33par.sel'
      call fndsel(ier,seln,selfil)
      lls=len_trim(selfil)
      if(ier.ne.0) call stopms('DNNpar.sel selection file not found')
      call lpst
      write(6,1) selfil(1:lls)
1     format(' runnex - NeXus file parameter listing'//
     1' Using selection file ',a//
     1' Give first and last run numbers : ',$)
      read(5,2)lin
2     format(a)
      read(linn,*) irst,last
      if(irst.le.0) call stopms('No run requested')
      if(last.lt.irst) last=irst
      do j=irst,last
      numor=j
      write(numc,20) j
20    format(i6.6)
      fname=path(1:lp)//numc//'.nxs'
      llp=lp+10
      call pripar(fname(1:llp),selfil(1:lls))
      end do
      call lped
      end
      subroutine pripar(fname,selfil)
      parameter(NXY=100*512*512)
      common/rbuf/v(NXY)
      common/cindx/ionce,numor
      common/ccolt/coltit(12)
      character fname*(*),selfil*(*)
      character ppath*50,vc*120,coltit*12,cfield*16
      integer iv(NXY),idim(10)
      real vv(20)
      logical found
      equivalence(v,vc,iv)
      cfield=' '
c***** only allow one character field
      inquire(file=fname,exist=found)
      if(.not.found) write(*,*) ' File not found ',fname
      if(.not.found) return
      lf=len_trim(fname)
c***** skip first line - could be comment
c      write(*,*)' pripar selfil '
      open(unit=1,file=selfil,status='old')
      read(1,10,err=20,end=20) ppath
10    format(a)
      call oldh5(ier,id_f,fname(1:lf),'O')
c      write(6,*)' opening file ',fname(1:lf)
      ncol=0
      do i=1,12
      read(1,10,end=20) ppath
c      if(ionce.eq.1) write(*,*) 'seek meta',ppath
      lp=len_trim(ppath)
      call readds(ier,id_f,ppath(1:lp),v,ir,idim,iitype)
      nin=idim(1)
      if(iitype.gt.0) ncol=ncol+1
      if(iitype.eq.0.and.cfield.eq.' ') cfield(1:nin)=vc
      if(iitype.eq.1) vv(ncol)=iv(1)
      if(iitype.eq.2) vv(ncol)=v(1)
      if(ionce.eq.0.and.iitype.gt.0)
     1call setcolt( coltit(ncol),ppath(1:lp))
      end do
20    if(ionce.eq.0) write(6,30) (coltit(i),i=1,ncol)
      if(ionce.eq.0) write(16,30) (coltit(i),i=1,ncol)
30    format(' Run ',22x,12a12)
      ionce=1
      write(6,40) numor,cfield,(vv(i),i=1,ncol)
      write(16,40)numor,cfield,(vv(i),i=1,ncol)
40    format(i7,2x,'"',a12,'"',2x,12g12.4)
      continue
      close(unit=1)
      call oldh5(ier,id_f,fname(1:lf),'C')
      return
      end
      subroutine setcolt(coltit,dsname)
c**** takes dataset name after group name 
      character coltit*(*),dsname*(*)
      coltit=' '
      ld=len(dsname)
      do i=ld,1,-1
       j=i
       if(dsname(i:i).eq.'/') go to 20
      end do
20    continue
      coltit=dsname(j+1:ld)
c      write(*,*) coltit
      return
      end
      subroutine lpst
c**** simplified lpout
      common/lpsted/fnam
      character pnam*4,fnam*11
      nseq=1
      pnam='rnxs'
      open(unit=16,file='sequ.seq',status='unknown',form='formatted')
      read(16,1,err=20,end=20) nseq
1     format(1x,i5)
      nseq=nseq+1
      if(nseq.gt.999) nseq=1
      close(16)
20    open(unit=16,file='sequ.seq',status='unknown',form='formatted')
      write(16,1) nseq
      close(16)
      write(fnam,2) pnam,nseq
2     format(a4,i3.3,'.lis')
      open(unit=16,file=fnam,status='unknown',form='formatted')
      return
      end
      subroutine fndsel(ier,sfil,selfil)
c***** looks for selection file locally then in SAS_DIR
      character*(*) selfil,sfil
      character*100 sasdir*100
      logical found
c      write(*,*) ' opsel ',selfil,'::'
      sasdir=' '
      selfil=sfil
      ier=-1
      call getenv('SAS_DIR',sasdir)
      lsd=len_trim(sasdir)
c***** name of selection-help file depends on instrument
      inquire(file=selfil,exist=found)
c      write(*,*) 'seek ',selfil,found
      if(found) go to 20
      if(.not.found) selfil=sasdir(1:lsd)//sfil
      inquire(file=selfil,exist=found)
      if(.not.found) return
20    ier=0
      return
      end
      subroutine lped
      common/lpsted/fnam
      character*11 fnam
      close(unit=16)
      write(6,1) fnam
1     format(' Closing listing file ',a)
C***** pause for prop/dosd
      call stopms('finishing')
      return
      end
      subroutine stopms(msg)
c***** for prop on MS pause before closing window
      character*(*) msg
      character*20 os
      if(msg.eq.' ') stop
      write(6,*) msg
      call getenv('OS',os)
      if(os.eq.'Windows_NT') call sleep(5)
      stop
      end
