::catch  {};#\
@echo off
::catch {};#\
@"%prop_dir%\expect-5.21\bin\wish80.exe" %0 %1 %2
::catch {};#\
@goto eof
#puts "argv0='argv0' argc=$argc argv='$argv' pwd='[pwd]'"
#!/usr/local/bin/expectk -f
#Splots Tk package for viewing data from small angle instruments
#Requires splots  from splots.f splotf.f + librlib.a libpgplot.a
#and monbug and pdqheads
#S.Fayers v1.1 14/11/95
#
#S. Fayers v1.2 24/11/95
# Buttons added to load default colours or greyscales.
#S. Fayers v1.21 27/3/96
# minor changes to functionality
#R. Ghosh April 1997
# minor edits to assume all spawned files are in $env(SAS_DIR)/
# Ch. Lacaille-Desse/R. Ghosh  version 2  June 1997
# normalisation options/treated data/windows added
#R. Ghosh October 1999
# reading compressed files added...
# help file corrected for WINDOWS December 2006 (Ron)
#May 2008 R.G.  mods for NEXT/PREVIOUS and deal with different terminators
#September 2010 R.G. mods to deal with mixed files in raw directory (v2.1)
#October 2010  cache file version (v2.2)
#
# NEEDS zcat and mkdir and rm in PATH 
#
#(PC-> zcat.exe,mkdir.exe,rm.exe in SAS_DIR)
#November 2010 pdqheads replaced by tcl procedures to get title info directly
#April 2011 timeout remooved; test for delete window added
#January 2012  'set levels' now disabled!
# note enter top/bottom values with <return>; negative log and sqrt in splots
#January 2012 for D16 show gamma and omega from file in raw mode titles
#May 2012 for OSX use gzcat to avoid switches in exec statement
#September 2012 add nx2as for NeXus files
#October 2015  modify to nxs2as for NeXus files
# check for environment variables
# SAS_DATA_PATH    (necessary)
# SAS_INSTRUMENT   (necessary)
# SAS_DIR          (necessary)
# SAS_DECOMPRESS (optional - usually present)
# SAS_CACHE  (necessary)

global env 
global cmdfil repfil inffil logfil exenam pnam cseq jnam debug sseq psfil
global seq pstn cmdout pgdir npointin 
global numor itype
global databottom datatop avg bottomlimit toplimit
global winx0 winx1 winy0 winy1 limx0 limx1 limy0 limy1 lraw
global norm therun theext runsindex startsec tempsqr
global selectdata zcat datapath cachedir calc_timeout exitt timeup mydir
global nxsfil cachepresent nxtran

####################  debpro   uses inframe to set debug status for comms
proc debpro  {} {
global debug 
set dwtle "Debug setting"
toplevel .d
label  .d.debug1 -text "this is a dummy db1"
pack .d.debug1 -side top -fill x
label  .d.debug2 -text "this is a dummy db2"
pack .d.debug2 -side top -fill x
}
######################  dblocate     debug window

proc dblocate  W {
toplevel .dbl
frame .dbl.f
label .dbl.f.label -text " ... $W ..." -fg red
button .dbl.f.but -text "OK" -command {destroy .dbl }
pack .dbl.f.label  .dbl.f.but
pack .dbl.f
focus .dbl
grab set .dbl
tkwait window .dbl
}
##################### updatinfo  reads fif file and updates paras and listbox
proc updatinfo  {} {
#PROGRAM SPECIFIC
global numor itype
global databottom datatop avg bottomlimit toplimit
global winx0 winx1 winy0 winy1 limx0 limx1 limy0 limy1 lraw
global norm therun theext 
global inffil runext runsindex

#  read fif file...

if [ catch {open $inffil r } inf ] { 
      set err " fif file error "
       dblocate  $err
   } else {

set nline 0
set npars 0
gets $inf parms
# first line is program id and date
gets $inf parms
# second line is return message
gets $inf parms
# third line is spare
gets $inf line
set numorext [lindex $line 0]
set itype    [lindex $line 1]
# runext type
gets $inf line
set databottom [lindex $line 0]
set datatop [lindex $line 1]
gets $inf line
set limx0 0
set limy0 0
set winx0 [lindex $line 0]
set winx1 [lindex $line 1]
set limx1 [lindex $line 2]
set winy0 [lindex $line 3]
set winy1 [lindex $line 4]
set limy1 [lindex $line 5]
gets $inf line
set therun [lindex $line 0]
set theext [lindex $line 1]
set norr [lindex $line 2]
set norm "n"
if { $norr != 0 } { set norm "y" }
#scan $line (%d%d%d) norm norrun norext
# norm normrun normext
#gets $inf sixp
# sixpack
close $inf
}
}
#==============
proc filinrx { } {
global selectdata zcat datapath nxsfil cachepresent
            .setruns.files delete 0 end
            if { $selectdata == "r" } {
	    set mydir [pwd ]
            cd $datapath
# don't sort raw data - assume in sequential order
            foreach i  [glob -nocomplain \[0\-9\]?????] {
	    .setruns.files insert end [concat $i 0] 
	                                                       }
            foreach i [glob -nocomplain \[0\-9\]?????.nxs] {
	    set nxsfil 1
            regexp {[0-9].....} $i ffff

	    .setruns.files insert end [concat $ffff 0]
                                                        }
            if { $nxsfil == 1 } { set zcat nodecompress }
            if { $zcat != "nodecompress" } {
# don't sort raw data - assume in sequential order
            foreach i [glob -nocomplain \[0\-9\]?????.Z] {
            regexp {[0-9].....} $i ffff

	    .setruns.files insert end [concat $ffff 0]
                                                        }
            foreach i [glob -nocomplain \[0\-9\]?????.gz] {
            regexp {[0-9].....} $i ffff

	    .setruns.files insert end [concat $ffff 0]
                                    }
	    }						       
	  cd $mydir
          } 
	    if { $selectdata == "t" }  { 
            .setruns.files delete 0 end
            foreach i [lsort [glob -nocomplain t\[0\-9\]?????.???] ]  {
	    set i [string range $i 1 10] 
	    set i1 [string range $i 0 5]
	    set i2 [string range $i 7 9] 
	    set i [concat $i1 $i2 ]
            .setruns.files insert end $i
	         }
          }
#	update idletasks
	return
}

proc addins {} {
# gets highlighted list of data, (decompresses) and aaddsin runs+titles
global selectdata zcat cachedir  startsec tempsqr env mydir rawpath nxsfil nxtran
set oneval [.setruns.files get anchor]  
set twoval [.setruns.files get active] 
# get list of highlighted runs
set runlist {}
set runhead {}
if { $zcat != "nodecompress" } {
#try looking for raw Z or gz files and decompress to cachas
set zzcat [lindex $zcat 0]
#for tcl strips of switch - choice between gunzip and zcat...
set zswit ""
# Osx can't put switch inside exec filename
#if { $zzcat == "gunzip" } { set zswit " -c "  }
# avoids exact detail of gunzip command and trailing spaces
# zcat on OSX adds .Z terminator ==> use gzcat  (variant of gzip -cd )
if { $zzcat == "gunzip" } { set zzcat  gzcat }
}
foreach item [.setruns.files curselection] {
set currun [.setruns.files get $item]
set runlist [linsert $runlist end $currun]
#puts " $currun $zzcat"
if { $selectdata == "t" } {
set frun [lindex $currun 0]
set fext [lindex $currun 1]
set thh [pdqheads $frun $fext ]
lappend runhead $thh 
}

if { $selectdata == "r" } {
set path $env(SAS_DATA_PATH)
set frun [lindex $currun 0 ]
set fext 0
#
#is file actually in data_path?
set rawpath $path
set ffound [file exists $path/$frun ]
if { $ffound == 0 } {
#decompress here to cache if necessary and get headers
# look in freshly decompressed file for header
        set rawpath $cachedir
	set ffound [ file exists $cachedir/$frun ]
	if { $ffound == 0 } {
	if { $zcat != "nodecompress" } {
	set runZ $path$frun.Z
	set rungz $path$frun.gz
	set rgz1 unsetrgz1
	set rgz2 unsetrgz2
	set resZ1 unsetresZ1
	set resZ2 unsetresZ2
	set gzf [file exists $rungz ]
	if { $gzf == 1 } {
	  exec $zzcat $rungz > $cachedir/$frun
	}
	set Zf [file exists $runZ ]
	if { $Zf == 1 } {
	  exec  $zzcat $runZ > $cachedir/$frun
	} }
	if { $nxsfil == 1 } {
	exec $nxtran $frun
	}
        set rawpath $cachedir
		}
} 
set thh [pdqheads $frun $fext ]
lappend runhead $thh
}
update idletasks
#
}
         


if {$runlist == ""} {return} ; #SI LA LISTE EST VIDE...

# destroy all the children of the setruns window and the window itself
eval destroy [winfo children .setruns]
destroy .setruns

update idletasks
cd $mydir
# mark end of current run select list
set startsec [ .slctruns index end ]
incr startsec -1
# because we're going to give a next command for plotting
# now add to runlist with numor/ext/title for all runs selected

foreach descrip $runhead {
.slctruns insert end $descrip
}

update idletasks
.slctruns see end
set runsindex $startsec 
# use back cos next starts at line 2....
wm deiconify .
.back invoke
if { $tempsqr == 0 } {
set tempsqr 1
.rsqr invoke
# first time - set scales to sqrt
}
update idletasks
# first time round set sqrt scales...since we have data
################### end of setruns action ###############################
}

###########################################################################
# reads ILL raw data and returns Short Title (or Title ) Ron Ghosh, Nov. 2010
# reads ILL treated 2D data returning short title
proc skipl { ff nextra} {
#skips text comments
set ii $nextra
while { $ii > 0 } {
gets $ff line
incr ii -1
}
return
}
proc findffield { ff } {
# finds first FFFFFF field in ILL raw data and returns gamma and omega for D16
set ii "abcd"
while { $ii != "FFFF" } {
gets $ff line
set tag [ string range $line 1 10 ]
if { $tag == "FFFFFFFFFF" } { set ii "FFFF" }
}
gets $ff line
set nextra [lindex $line 1]
if { $nextra > 0 } { skipl $ff $nextra }
gets $ff line
# first para line
gets $ff line
set omegaa [lindex $line 0]
set omega [format "%6.2f" $omegaa ]
set gammaa [lindex $line 1]
set gamma [format "%6.2f" $gammaa ]
set rets "O=$omega G=$gamma"
return $rets
}
proc pdqheads { fnum fext} {
global env rawpath lraw 
global cachedir
global ff
set  headread " $fnum/000 ERROR reading data"
# actually numor not OK but any error really
if { $fext == 0 } {
#reads raw data title
set fname $rawpath/$fnum
set ff [open $fname r ]
gets $ff line
gets $ff line
# check numor after RRRRRR!
set numor [ string range $line 2 7 ]
if { $numor != $fnum } { 
close $ff
return $headread }
set afield 0
set lastafield 0
# first AAA filed is instrument name
while { $afield < 2 } {
gets $ff line
set tag [ string range $line 1 10 ]
if { $tag == "AAAAAAAAAA" } { incr afield }
if {$afield > $lastafield } {
incr lastafield
if { $lastafield == 1 } {
gets $ff line
# should test for skippable text (2nd field non 0 )
set nextra [ lindex $line 1]
if { $nextra > 0 } { skipl $ff $nextra }
gets $ff line
# check instrument against $SAS_INSTRUMENT
set finst [lindex $line 0]
if { $finst != $lraw } {
set headread " $fnum/000 ERROR not $lraw data"
close $ff
return $headread }
}
# 
}
}
gets $ff line
# should test for skippable text (2nd field non 0 )
set nextra [ lindex $line 1]
if { $nextra > 0 } { skipl $ff $nextra }
gets $ff line
set head [string range $line 60 79 ]
set blankl "                    "
if { $head == $blankl } {
    set head [string range $line 0 19 ] }
set headread " $fnum/000 $head"
if { $lraw != "D16" } { 
close $ff
return $headread 
}
# can we find omega for D16 ??
# skip to next F field
set angls [ findffield $ff ]

set headread " $fnum/000 $angls "
close $ff
return $headread

}
if { $fext != 0 } {
#treated data
# returns short-title from treated data (first 20 characters)
set  headread " $fnum/$fext ERROR reading data"
set fname "t$fnum.$fext"
set error [file exists $fname ]
if { $error != 1 } { return  $headread  }
set ff [open $fname r ]
gets $ff line
set head [ string range $line 0 19 ]
close $ff
set headread " $fnum/$fext $head"
return $headread
}  
}

#----------LACAILLE----------------PROCEDURE NORMALIZE---------------------
proc normaliz { } {
global therun theext norm
toplevel .normalize ; wm geometry .normalize +490+290
frame .normalize.f 
pack .normalize.f 
frame .normalize.f1 

pack .normalize.f1 -in .normalize.f -side top
frame .normalize.f2 
pack .normalize.f2 -in .normalize.f -side top

label .normalize.normrun -text "Run Number ?" 
entry .normalize.runent -width 6 -textvariable therun
label .normalize.runext -text "Extension ?" 
entry .normalize.runextent -width 3 -textvariable theext
button .normalize.runaplly -text "Seek Run"  -width 15 \
    -command {
     sendcmd "inn"
    .normalize.normnew configure -text "Normalize ?"
    .normalize.chknormy configure -state normal
    .normalize.chknormn configure -state normal
    set norm y
    set therun [.normalize.runent get]
    set theext [.normalize.runextent get]
    set setr $therun
    set sete $theext
#   cos - if error these are reset to 0
    sendcmd "$therun $theext"
    set tttt  [string match "*eviation*" $frep ]
        if {[string match "*eviation*" $frep ] < 1 } {
	    set therun 0 ; set theext 0
	    .normalize.normnew configure -text ""
	    .normalize.chknormy configure -state disabled
	    .normalize.chknormn configure -state disabled
        set norm n
	dblocate " Normalisation run $setr $sete not found "				           } 
      	     }          

label .normalize.normnew -text "Normalize ?" 
radiobutton .normalize.chknormy  -text YES  -variable norm -value y \
 -command { set norm y ; sendcmd "+nd" }
radiobutton .normalize.chknormn  -text NO  -variable norm -value n \
 -command { set norm n ;sendcmd "-nd" }

button .normalize.dism -text Dismiss -width 15  -command {destroy .normalize}

pack .normalize.normnew .normalize.chknormy .normalize.chknormn \
-in .normalize.f -side left -expand 1 -fill both
pack .normalize.normrun .normalize.runent .normalize.runext \
.normalize.runextent -in .normalize.f1 -side left -expand 1 -fill both
pack  .normalize.runaplly .normalize.dism -in .normalize.f2 -side left -expand 1 -fill both
focus .normalize
grab .normalize
.normalize.normnew configure -text "" 
if {$therun == 0 } {
             .normalize.chknormy configure -state disabled
             .normalize.chknormn configure -state disabled
	           } else {
.normalize.chknormn configure -state normal
.normalize.chknormy configure -state normal
                          }
}
#----------------END NORMALIZE---------------------

#-------LACAILLE----------------PROCEDURE SETWIN---------------------
proc setwin {  } {
global winx0 winx1 winy0 winy1 limx0 limx1 limy0 limy1 lraw
updatinfo
		    
toplevel .set_window ; wm geometry .set_window +490+290
frame .set_window.f ;pack .set_window.f  
frame .set_window.f1 ;pack .set_window.f1 
frame .set_window.f2 ;pack .set_window.f2 


label .set_window.setw -text "WINDOW SIZE  from X:"
entry .set_window.entx0 -width 5 -textvariable winx0
label .set_window.setx1 -text "to X:"
entry .set_window.entx1 -width 5 -textvariable winx1
label .set_window.sety0 -text "WINDOW SIZE  from Y:"
entry .set_window.enty0 -width 5 -textvariable winy0
label .set_window.sety1 -text "to Y:"
entry .set_window.enty1 -width 5 -textvariable winy1

button .set_window.wind -text "SET WINDOW"  -command {
            set limx0 0 
	    set limy0 0
	    set winx0 [.set_window.entx0 get] ; set winx0 [expr $winx0 ]
	    set winx1 [.set_window.entx1 get] ; set winx1 [expr $winx1 ]
	    set winy0 [.set_window.enty0 get] ; set winy0 [expr $winy0 ]
	    set winy1 [.set_window.enty1 get] ; set winy1 [expr $winy1 ]
	    if { $winx0 <= 0 || $winx0 >= $limx1 } { set winx0 $limx0 }
	    if { $winx1 <= $winx0 || $winx1 >= $limx1 } { set winx1 $limx1 }
	    if { $winy0 <= 0 || $winy0 >= $limy1 } { set winy0 $limy0 }
	    if { $winy1 <= $winy0  || $winy1 >= $limy1 } { set winy1 $limy1 }
            sendcmd "w"
	    sendcmd "$winx0 $winx1 $winy0 $winy1"
# don't need to check result...		                                      }
		                                     
button .set_window.windf -text "FULL WINDOW" -command {
	    sendcmd "w"
	    sendcmd " "
#check  from updatwinfo ...?
	    set winx0 $limx0
	    set winx1 $limx1
	    set winy0 $limy0
	    set winy1 $limy1
		                                      }

button .set_window.dism -text "Dismiss" -command {destroy .set_window}

pack .set_window.setw .set_window.entx0  .set_window.setx1 .set_window.entx1 -in .set_window.f -side left \
-expand 1 -fill both
pack  .set_window.sety0 \
.set_window.enty0 .set_window.sety1 .set_window.enty1   -in .set_window.f1 -side left -expand 1 -fill both
pack .set_window.wind .set_window.windf \
.set_window.dism -in .set_window.f2 -side left -expand 1 -fill both
focus .set_window
grab .set_window

}
#----------------END SETWIN---------------------

##################   sendcmd  writes/reads communications with fitfun program
proc sendcmd { cmdout} {
global  debug npointin frep repl calc_timeout timeup
global cmdfil repfil inffil logfil pnam cseq exenam exitt mydir
#puts "sendcmd seq $cseq $cmdout $repfil"
cd $mydir
# ensures all commands are written in cwd
set cf [ open $cmdfil w ]
incr cseq
if { $cseq > 999 } { set cseq 2 }
# command 1 is to send prelude info only
set tmp $cseq
if { $cseq < 100 } { set tmp " $cseq" }
if { $cseq < 10 } { set tmp "  $cseq" }
puts $cf "$tmp:$cmdout\n"
close $cf
#puts "done $cseq $cmdfil"
if { $exitt == "now" } { exit } 
###### now await reply (resout string is in $frep)
set ticks 0
if { $debug == 1 } {.d.debug1 configure -text $ticks }
while { $ticks < $timeup } {
  incr ticks
  set tticks $ticks
if {$debug == 1} {.d.debug2 configure -text " reading after $ticks tcks" }
update idletasks
  after 100
#### look for reply file
   set repl "waiting"
  if  { [ catch { open $repfil r  }  inr ] == 0 } { 
#### file found - read and update if ccseq = cseq
if { $debug == 1 } {.d.debug1 configure -text " reading after $ticks tcks" }
  gets $inr repl
#  puts "rpeply $repl"
  close $inr
if {$debug ==1 } {.d.debug2 configure -text "ttt $repl ttt" }
  set rrep [split $repl |]  
  set ccseq [ lindex $rrep 0 ]
  set frep [ lindex $rrep 1 ]
  if { $ccseq >= $cseq } { 
  set ticks 11111 
  ###### set comment to reply
  } 
set rr [ lindex $rrep 1 ]
set ll [llength $repl ]
}
# after loooking at reply file
if { $debug == 1 } {
#puts "ticks $ticks"
.d.debug1 configure -text " After $$ticks ticks "
.d.debug2 configure -text  "replied: $repl"
update idletasks

}
if { $ticks == $timeup } {
#then program has not replied - close it down and signal lack of reply
dblocate "No reply from slaved program "
exit
}
# end of wait loop next
}


}

####################  - gets sequence number, starts fitfun/comm prgram with job number 
proc iniseq  {} {
global cmdfil repfil inffil logfil exenam pnam cseq jnam debug sseq psfil
global seq pstn cmdout pgdir npointin env mydir
cd $mydir
# ensures all comms in cwd
set npointin 0
#  read sequ.seq file...

set fname sequ.seq
if [ catch {open $fname r } ins ] {
       set seq 0
   } else {
gets $ins seq
close $ins
}
if { [ catch { expr $seq } ] == 0 } {
incr seq 
} else {
set seq 1 }
# when starting in a new directory 
if { $seq > 999 } {
set seq 1
}
set ins [ open $fname w ]
set sp1 " "
set sp2 "  "
set  tmp $seq
# slight problems to match Fortran I5 formats!
if { $seq < 100 } { set tmp " $seq" }
if { $seq <10 } { set tmp "  $seq" }
puts   $ins "  $tmp\n" 
close $ins
set tmp [format  "%03d" $seq ]
set  cmdfil "$pnam$tmp.fcd"
set repfil "$pnam$tmp.frp"
set inffil "$pnam$tmp.fif"
set logfil "$pnam$tmp.log"
set jnam "job$tmp"

# for possible psfile output..
set sseq $seq
incr sseq
if { $sseq > 999 } { set sseq 1 }
set tmp [ format "%03d" $sseq ]
set psfil "$pnam$tmp.ps"
#.main.tt configure -text " Welcome to Fitfun running $exenam" -fg blue
# command sequence number
set cseq 0
### start program
# BEWARE env must be a global here
set gggg [exec  $exenam $jnam  &]
}
#xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
#xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
#xxxxxxxxxxxxxxxxxxxxxxxxxx back to xplots xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
#xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
#xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
#xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

########################################################################
####################################################################
set pnam xplo
set delcmd rm

set version 3.6
set exenam splots.exe
set nxtran nxs2as.exe
set pform $tcl_platform(platform)
if { $pform == "unix" } {
catch { exec monbug XPOL $version } reslt
set exenam $env(SAS_DIR)/splots
set nxtran $env(SAS_DIR)/nxs2as
}
#wm iconify . 
set runsindex 0
# first time around...

# for Mac OSX setenv SAS_DECOMPRESS gunzip -c
# for Linux   setenv SAS_DECOMPRESS zcat
# for PC      set    SAS_DECOMPRESS=zcat
set zcat "nodecompress"
#set cachedir cashas
set ccc ""
catch { set ccc $env(SAS_CACHE) } reslt
if { $ccc == "" } { dblocate { " SAS_CACHE has not been defined " } }
if { $ccc == "" } exit
set cachedir $ccc
# set as default cache name
catch { set zcat $env(SAS_DECOMPRESS) }  reslt
if { $zcat != "nodecompress" } {
# look for env SAS_CACHE
set newcache ""
catch { set newcache $env(SAS_CACHE) } reslt
if { $newcache != "" } { set cachedir $newcache }
set foundd [ file isdirectory $cachedir ]
if { $foundd == 0 } { 
catch { set aa [ exec mkdir $cachedir ] } reslt
# make a cache dir available
}
}
# -----------------------------------------------------------------------
# store current directory
set mydir [ pwd ]
# -----------------------------------------------------------------------
#create the frames to put the buttons in

wm title . "Xplotx v$version  S.Fayers & Ch.Lacaille-Desse, (RG 1996-2012)"
# Trap close GUI window button - emit terminate command to spawned task
wm protocol . WM_DELETE_WINDOW { 
set exitt "now"
sendcmd "E"
exit
}
 
frame .left -bd 4 -relief groove
frame .right
frame .top -bd 4 -relief groove -height 1c
frame .bottom 
frame .bl  -bd 4 -relief groove
frame .br -bd 4 -relief groove
frame .bml -bd 4 -relief groove
frame .bmr -bd 4 -relief groove

#and pack them in a logical order
pack .left .right -side left -expand 1 -fill both
pack  .top  -in .right  -side top -fill x
pack .bottom -in .right -side top -expand 1 -fill both
pack .bl .bml .bmr .br -in .bottom  -expand 1 -fill both -side left


global selectdata run1 run2 comment norm
set selectdata r ;set comment ""
	

# -----------------------------------------------------------------------
# create a change runs button, with appropriate functionality
button .changeruns -text "Change Run Range" -command {
wm iconify .
# create a new window to select runs from; save last entered run position
set runsindex [.slctruns index end]
toplevel .setruns ; wm geometry .setruns +500+70
wm protocol .setruns WM_DELETE_WINDOW { 
wm deiconify .
destroy .setruns
}
wm title .setruns "Xplots Run Selector"
# ensure that the new window is in focus
focus .setruns
grab .setruns
frame .setruns.a 
frame .setruns.a1 
frame .setruns.a2 
frame .setruns.b
pack .setruns.a  .setruns.a1 .setruns.a2  .setruns.b -in .setruns 
set datapath $env(SAS_DATA_PATH)
listbox .setruns.files -relief raised -width 35 -bd 2 -yscrollcommand ".setruns.scroll set"
scrollbar .setruns.scroll -command ".setruns.files yview"
pack .setruns.scroll -in .setruns.b -side right -fill y
# read the data files, inserting them into the list
filinrx
# place end of selector window viewable
.setruns.files see end
pack .setruns.files -in .setruns.b -expand 1 -side left -fill both
.setruns.files configure -height 25 -selectmode extended 
label .setruns.info -text "The following runs are available. \
Select the ones of interest and click OK" -wraplength 320
set lraw [string toupper $env(SAS_INSTRUMENT)] 
set braw [concat "RAW data for SAS_INSTRUMENT :" $lraw]
radiobutton .setruns.r1 -text $braw  -variable selectdata   -anchor w -value r\
 -command { 
		set selectdata r
		filinrx
          } 
radiobutton .setruns.r2 -text "TREATED data"   -anchor w -variable selectdata -value t \
 -command { 
	set selectdata t
	filinrx
          }
button .setruns.dismiss -text Dismiss -command {
wm deiconify .
destroy .setruns
} 
#button .setruns.dismiss -text Dismiss -command {return} 
button .setruns.ook -text OK -width 25 -command { addins } 
pack .setruns.info    -in .setruns.a -side left
pack .setruns.r1 .setruns.r2 -in .setruns.a1 -side top -expand 1 -fill both
pack .setruns.ook .setruns.dismiss  -in .setruns.a2 -side left
}
############################################################################
########################## end of chngruns section ?#########################
############################################################################
pack .changeruns -in .top -ipady 2m -side left -expand 1 -fill both
frame .a
frame .b
pack .a .b -side top -in .left -expand 1 -fill both
listbox .slctruns -height 12 -selectmode single -yscrollcommand \
 ".slctscroll set"
	    scrollbar .slctscroll -command ".slctruns yview"
label .lab -text "Select a run by double-clicking with the left mouse \
button \n The next and back buttons in the main window will select the\
next and previous runs in this list" -wraplength 300
pack .lab -in .a
pack .slctscroll -in .b -side right -fill y -expand 1 
pack .slctruns -in .b -side left -expand 1 -fill x

#
# Double click in selector panel
#
bind .slctruns <Double-1> {
set runsindex [.slctruns index active]
set numor [lindex [.slctruns get active] 0]
set dhead [lindex [.slctruns get active] 1]
if { $dhead != "ERROR" } {
#puts "changeruns $numor numor"
# numor is in format nnnnnn/mmm 
         set run1_1 [string range $numor 0 5]
	 set run2_1 [string range $numor 7 9] 
	 if {$locked == 1} {
         sendcmd "r"
	 } else {
	 sendcmd "NA"                   
	 }
         sendcmd "$run1_1 $run2_1 0 "
         if {$itype == 3} {set itype 0}
	if {$locked ==0} {
		set bottomlimit $databottom
		set toplimit    $datatop
	}
.slctruns selection anchor $runsindex
.slctruns see $runsindex
#*********************************************************
}
}

# -----------------------------------------------------------------------
#create back, next and help buttons
button .next -text NEXT -command {
# increase the run number by one

set hhhh [.slctruns index end ]
incr hhhh -1
####### don't ask why PC-tk returns (end+1) ########
.slctruns selection clear $runsindex
if {$runsindex < $hhhh } {incr runsindex }
.slctruns selection clear active
.slctruns selection set $runsindex
# .slctruns curselection can return more than one index if listbox is maltreated
.slctruns see [.slctruns curselection]
set aaaa [.slctruns curselection ]
set numor [lindex [.slctruns get [.slctruns curselection]] 0]
set dhead [lindex [.slctruns get [.slctruns curselection]] 1]
if { $dhead != "ERROR" } {
         set run1_1 [string range $numor 0 5]
	 set run2_1 [string range $numor 7 9]
# numor is in format nnnnnn/mmm 
# send info to splots.f and get back data limits
	 if {$locked == 1} {
         sendcmd "n"
	 } else {
         sendcmd "NA"
	 }
        sendcmd "$run1_1 $run2_1 0 "
        updatinfo
        if {$itype == 3} {set itype 0}
	if {$locked ==0} {
		set bottomlimit $databottom
		set toplimit    $datatop
		}
#.slctruns see end
}
}
button .back -text PREVIOUS -command {
# decreases the run number by one
#puts "BACK selected"
.slctruns selection clear $runsindex
if {$runsindex > 0 } {  incr runsindex -1 }
.slctruns selection clear active
.slctruns selection set $runsindex

.slctruns see [.slctruns curselection]
set numor [lindex [.slctruns get [.slctruns curselection]] 0]
set dhead [lindex [.slctruns get [.slctruns curselection]] 1]
#puts "BACK $numor $dhead"
if { $dhead != "ERROR" } {
# numor is in format nnnnnn/mmm 
         set run1_1 [string range $numor 0 5]
	 set run2_1 [string range $numor 7 9] 
# send info to splots.f and get back data limits
	 if {$locked == 1} {
         sendcmd "n"
	 } else {
         sendcmd "NA"
	 }
        sendcmd "$run1_1 $run2_1 0 "
	updatinfo
        if {$itype == 3} {set itype 0}
	if {$locked ==0} {
		set bottomlimit $databottom
		set toplimit    $datatop
		}
}
}

button .shelp -text HELP!! -command {
set opwd [pwd]
cd $env(SAS_DIR)
exec htmltk.bat xplotshelp/xplots.htm &
cd $opwd
}



pack .back .next .shelp -in .top -ipady 2m -side left -expand 1 -fill both  
# -----------------------------------------------------------------------
#create buttons to select no per page, save, load cols and colour file
button .six -text "The `Six-Pack'"  \
 -anchor w -command {
        sendcmd "SIX"
	}


button .storeops -text "Store/Delete/Retrieve" -anchor w -command {
#create a new window
sendcmd "SIX"
toplevel .storef ; wm geometry .storef +280+390 
wm title .storef "Xplots Store"
frame .storef.sbr
frame .storef.sbl
frame .storef.stl
frame .storef.str
frame .storef.stop
frame .storef.sbottom
pack .storef.stl .storef.str -in .storef.stop -side left -expand 1 -fill both
pack .storef.sbl .storef.sbr -in .storef.sbottom -side left -expand 1 -fill both
pack .storef.stop .storef.sbottom -in .storef -side left -expand 1 -fill both
# button to get rid of window when finished
button .storef.dismiss -text Dismiss -command {
focus . 
eval destroy [winfo children .storef]
destroy .storef
}
button .storef.da -text "Delete All" -command {

sendcmd "DA"
sendcmd "SIX"
}
pack .storef.dismiss .storef.da -in .storef.sbr -expand 1 -fill both

#create the frames and buttons to store the currnt data
frame .storef.st1
frame .storef.st2
frame .storef.st3


button .storef.1 -text "Store 1" -anchor w -command {
sendcmd "S1"
sendcmd "SIX"

set messagetext "Stored"
}

button .storef.2 -text "Store 2" -anchor w -command {
sendcmd "S2"
sendcmd "SIX"

set messagetext "Stored"
}

button .storef.3 -text "Store 3" -anchor w -command {
sendcmd "S3"
sendcmd "SIX"

set messagetext "Stored"
}

button .storef.4 -text "Store 4" -anchor w -command {
sendcmd "S4"
sendcmd "SIX"

set messagetext "Stored"
}

button .storef.5 -text "Store 5" -anchor w -command {
sendcmd "S5"
sendcmd "SIX"

set messagetext "Stored"
}

button .storef.6 -text "Store 6" -anchor w -command {
sendcmd "S6"
sendcmd "SIX"

set messagetext "Stored"
}

pack .storef.st1 .storef.st2 .storef.st3 -in .storef.stl -expand 1 -fill both
pack .storef.1 .storef.2 -in .storef.st1 -side left -expand 1 -fill both
pack .storef.3 .storef.4 -in .storef.st2 -side left -expand 1 -fill both
pack .storef.5 .storef.6 -in .storef.st3 -side left -expand 1 -fill both

# create the buttons to delete data from the store
frame .storef.de1
frame .storef.de2
frame .storef.de3


button .storef.d1 -text "Delete 1" -anchor w -command {
sendcmd "D1"
sendcmd "SIX"
set messagetext "Deleted"
}

button .storef.d2 -text "Delete 2" -anchor w -command {
sendcmd "D2"
sendcmd "SIX"
set messagetext "Deleted"
}

button .storef.d3 -text "Delete 3" -anchor w -command {
sendcmd "D3"
sendcmd "SIX"
set messagetext "Deleted"
}

button .storef.d4 -text "Delete 4" -anchor w -command {
sendcmd "D4"
sendcmd "SIX"
set messagetext "Deleted"
}

button .storef.d5 -text "Delete 5" -anchor w -command {
sendcmd "D5"
sendcmd "SIX"
set messagetext "Deleted"
}

button .storef.d6 -text "Delete 6" -anchor w -command {
sendcmd "D6"
sendcmd "SIX"
set messagetext "Deleted"
}



pack .storef.de1 .storef.de2 .storef.de3 -in .storef.sbl -expand 1 -fill both
pack .storef.d1 .storef.d2 -in .storef.de1 -side left -expand 1 -fill both
pack .storef.d3 .storef.d4 -in .storef.de2 -side left -expand 1 -fill both
pack .storef.d5 .storef.d6 -in .storef.de3 -side left -expand 1 -fill both

# create buttons to reload frames
frame .storef.re1
frame .storef.re2
frame .storef.re3

button .storef.r1 -text "Reload 1" -anchor w -command {
sendcmd "R1"
set messagetext "Reloaded" ;.storef.dismiss invoke
}
button .storef.r2 -text "Reload 2" -anchor w -command {
sendcmd "R2"
set messagetext "Reloaded" ;.storef.dismiss invoke
}
button .storef.r3 -text "Reload 3" -anchor w -command {
sendcmd "R3"
set messagetext "Reloaded" ;.storef.dismiss invoke
}
button .storef.r4 -text "Reload 4" -anchor w -command {
sendcmd "R4"
set messagetext "Reloaded" ;.storef.dismiss invoke
}
button .storef.r5 -text "Reload 5" -anchor w -command {
sendcmd "R5"
set messagetext "Reloaded" ;.storef.dismiss invoke
}
button .storef.r6 -text "Reload 6" -anchor w -command {
sendcmd "R6"
set messagetext "Reloaded" ;.storef.dismiss invoke
}
pack .storef.re1 .storef.re2 .storef.re3 -in .storef.str -expand 1 -fill both
pack .storef.r1 .storef.r2 -in .storef.re1 -side left -expand 1 -fill both
pack .storef.r3 .storef.r4 -in .storef.re2 -side left -expand 1 -fill both
pack .storef.r5 .storef.r6 -in .storef.re3 -side left -expand 1 -fill both
}

# create the button to save the parameters
button .save -text "Save Colours\nand Levels" \
	-command { sendcmd "S"}
#create the button to load the colour table
button .colours -text "Change Colours" -command {
toplevel .cols ; wm geometry .cols +535+325
focus .cols ; grab .cols
# first button is dummy - not clear why won't show up on OSX
button .cols.dumcol -text "" -command {
        sendcmd "LDC"
	}
button .cols.defcol -text "Default Colours" -command {
        sendcmd "LDC"
	}
button .cols.defgry -text "Default Greys" -command {
        sendcmd "LDG"
	}
button .cols.revcol -text "Reverse Colours" -command {
        sendcmd "LRC"
	}
button .cols.revgry -text "Reverse Greys" -command {
        sendcmd "LRG"
	}


button .cols.loadcols -text "Load from File" -command {
focus .

        sendcmd "C"
	sendcmd $colourfile
	if { [string range $frep 0 4] != "ERROR" } { sendcmd "RDW" }
		}
label .cols.colfile -text "FileName"
entry .cols.colourfile -width 20 -relief sunken -textvariable colourfile
button .cols.quit -text "Return" -command {
eval destroy [winfo children .cols]
destroy .cols
focus .
}
pack .cols.dumcol .cols.defcol .cols.revcol .cols.defgry .cols.revgry .cols.loadcols \
  .cols.colfile .cols.colourfile .cols.quit  -expand 1 -fill both
}

pack .six .storeops  -in .bl -fill x
pack .save .colours  -in .bl -expand 1 -fill both

set npp 1



# -----------------------------------------------------------------------
#create limit entries with annotation, and other buttons
label .topl -text "Top Limit:"
label .botl -text "Bottom Limit:"
entry .tle -width 10 -relief sunken -textvariable toplimit
entry .ble -width 10 -relief sunken -textvariable bottomlimit

#switch on and off auto limiting

# auto limit button sends splots.f parameter commmand and reads return
#create two buttons to lock and unlock limits
frame .lok 
radiobutton .lock -text "Limits Locked" -variable locked -value 1
radiobutton .unlock -text "Auto Limit" -variable locked -value 0

# the entry field for the top and bottom limits
bind .tle <Return> {
# ensure that the value is numeric
	if [expr $toplimit]  {
# check that the toplimit is above the bottomlimit
	if {$toplimit<$bottomlimit} {
	set messagetext "Toplimit below Bottomlimit"
	                } else {
	focus .
        sendcmd "T"
	sendcmd "$toplimit"
	}} else {
	set messagetext "This value must be numeric and has been auto set"
        set toplimit $datatop

	}
	           }
# entry field for bottom limit (same as top limit)
bind .ble <Return> {
# special case if set to zero !!!
        if { [expr $bottomlimit ] == 0 } {
	sendcmd "B"
	sendcmd "0"
	}
	if [expr $bottomlimit] {
	if {$toplimit<$bottomlimit} {
	set messagetext "Bottomlimit above Toplimit"
	} else {
	focus .
	sendcmd "B"
        sendcmd $bottomlimit
	}} else {
	set messagetext "This value must be numeric and has been auto set"
        set bottomlimit $databottom
	}
	}
# -----------------------------------------------------------------------
# create manual setup button, with new windowing commands
button .msetup -text "Set Levels"  -state disabled


# -----------------------------------------------------------------------
# create the scaling selector buttons
set lastitype 0
radiobutton .rlin -text Linear -variable itype -value 0 -anchor w\
-command {
sendcmd "LIN"
if { [string range $frep 0 4 ] != "ERROR" } { set lastitype 0 ; set messagetext "Linear OK"}
if { [string range $frep 0 4 ] == "ERROR" } { set itype $lastitype ; set messagetext "No Run"}
}      
radiobutton .rlog -text "Log Scale" -variable itype -value 1 -anchor w -command {
sendcmd "LOG"
if { [string range $frep 0 4 ] != "ERROR" } { set lastitype 1 ; set messagetext "Log OK"}
if { [string range $frep 0 4 ] == "ERROR" } { set itype $lastitype ; set messagetext "No Run"}
}
radiobutton .rsqr -text "Square Root" -variable itype -value 2 -anchor w -command {
sendcmd "SQR"
if { [string range $frep 0 4 ] != "ERROR" } { set lastitype 2 ; set messagetext "Log OK"}
if { [string range $frep 0 4 ] == "ERROR" } { set itype $lastitype ; set messagetext "No Run"}
}
radiobutton .rman -text "Manual Scale" -variable itype -value 3 -anchor w -command {
sendcmd "MAN"
if { [string range $frep 0 4 ] != "ERROR" } { set lastitype 3 ; set messagetext "Manual OK"}
if { [string range $frep 0 4 ] == "ERROR" } { set itype $lastitype ; set messagetext "No Run"}
}


pack .rlin .rlog .rsqr .rman -in .bmr -expand 1 -fill both 
pack .msetup .lok -in .bml -expand 1 -fill both -side bottom
pack .lock .unlock -in .lok -expand 1 -fill \
both
set itype 0
pack .topl .tle .botl .ble -in .bml -fill x -side top

# create the postscript button which uses the current display
button .ps -text PostScript -command {
sendcmd "P"
if { [string range $frep 0 4 ] != "ERROR" } {set messagetext "PostScript Printed"}
}

#creates the general reset button - always useful
button .zz -text "General Reset" -command {
set messagetext "Reset"
set itype 0
set npp 6
sendcmd "Z"
sendcmd " 0 0"
}

# creates the exit button which closes splots.f cleanly, then closes splots.tk
button .exit -text EXIT -command {
set exitt "now"
# delete cache files if default (unmanaged) cache in use should cd back to cwd...
            if {$zcat != "nodecompress" } {
	      if { $newcache == "" } {
cd $cachedir
catch { foreach i [ glob * ] {
set aa [ exec rm $i ] }  } resdel
cd $mydir
} }
set exitt "now"
sendcmd "E"
exit
}
pack .ps .zz .exit -in .br -expand 1 -fill both


frame .c
pack .c -in .right -side top -fill both
button .normlab -text "SET NORMALIZATION" -width 20 \
-command      {
normaliz    
#   needs to get these fro existing inforead
              }

button .wind -text "SET WINDOW"  -width 20 -command {setwin}
 
pack .normlab .wind  -in .c -side left

# start up splots in iniseq from $exenam

set cmdout " "

set debug 0
set nxsfil 0
set bug ""
catch { set bug $env(COM_DEBUG) } rslt
if { $bug != "" } { set debug 1 }
# use common debug flag for Fortran and GUI
set timeup 50
set intim ""
#catch { set tintim $env(COM_TIMEOUT) ; intim = expr tintim } rslt
#if { $intim != 0 }   { set timeup $intim }
# brings up panel with comms info
if { $debug == 1 } { debpro }
iniseq 
# this sets up communication filenames and starts external program
# program names are program specific
# updatinfo (and program "senn" *.inf writer) are program specific
set exitt ""
set tempsqr 0
# to change to SQRT scales first time around
#wm  deiconify .
set databottom 0
set datatop 100000

.unlock invoke
# first input is dummy prolog data
sendcmd " 0  "
sendcmd " 0  "
set selectdata r
# initially look for raw data
.changeruns invoke
# to terminate cleanly set $exitt "now"  - stops wait for no reply! 
#:eof
